FUNCTION InMemo
PARAMETERS Phrase, MemoFld, CaseSens
PUBLIC m_MemoRow, m_MemoCol           && ** Only for Memofind **
IF BOF() .OR. EOF() .OR. "" = DBF()   && If at beginning/end of
   RETURN .F.                         && file, or no file is in
ENDIF                                 && USE, nothing to process.
m_Phrase2 = IIF(CaseSens, Phrase, UPPER(Phrase))
m_Phrase1 = LEFT(m_Phrase2, AT(" ", m_Phrase2) - 1)
m_Phrase1 = IIF("" = m_Phrase1, m_Phrase2, m_Phrase1)
m_MemLines = MIN(MEMLINES(&MemoFld), 1170)      && Array limits
IF m_MemLines = 0       && If the memo field is empty, there is
   RETURN .F.           && nothing to process!
ENDIF
DECLARE a_Array[m_MemLines]
m_Occurs = 0
X = 1
DO WHILE X <= m_MemLines
   a_Array[x] = IIF(CaseSens, MLINE(&MemoFld, X), ;
      UPPER(MLINE(&MemoFld, X)))
   m_Occurs = m_Occurs + IIF(m_Phrase1 $ a_Array[x], 1, 0)
   X = X + 1
ENDDO
IF m_Occurs = 0       && If the memo does not even contain the
   RETURN .F.         && the first word in the phrase, RETURN .F.
ENDIF
X = 1
DO WHILE X <= m_MemLines
   m_Line = a_Array[x]
   DO WHILE AT(m_Phrase1, m_Line) > 0
      y = X
      m_Rest = SUBSTR(m_Line, AT(m_Phrase1, m_Line), LEN(m_Line))
      DO WHILE LEN(m_Rest) < LEN(Phrase)
         y = y + 1
         IF y > m_MemLines
            EXIT
         ENDIF
         m_Rest = m_Rest + IIF(RIGHT(a_Array[y - 1], 1) = ;
            CHR(32), "", " ") + a_Array[y]
         
      ENDDO
      IF IIF(CaseSens, Phrase, UPPER(Phrase)) $ m_Rest
         *--  ** Only for MemoFind ** From here .....
         IF IIF(CaseSens, Phrase, UPPER(Phrase)) $ a_array[y]
            m_MemoCol = AT(IIF(CaseSens, Phrase, UPPER(Phrase)), ;
               a_array[y]) - 1
            m_MemoRow = y - 1
         ELSE
            m_MemoRow = X - 1
            m_mCol1 = LEFT(a_array[x + 1], IIF(AT(" ",  ;
               a_array[x + 1]) = 0, LEN(a_array[x + 1]), ;
               AT(" ", a_array[x + 1]) - 1))
            m_MemoCol = LEN(a_array[x]) - IIF(CaseSens,  ;
               AT(m_mCol1, phrase), AT(UPPER(m_mCol1),  ;
               UPPER(phrase))) + IIF(RIGHT(a_Array[x], 1) = ;
               CHR(32), 1, 2)
         ENDIF
         *--  ** Only for MemoFind ** ...... to here.
         RETURN .T.
      ELSE
         IF y > m_MemLines
            EXIT
         ELSE
            m_Line = SUBSTR(m_Line, AT(m_Phrase1, m_Line) + ;
               LEN(m_Phrase1), LEN(m_Line))
         ENDIF
      ENDIF
   ENDDO
   X = X + 1
ENDDO
RETURN .F.
*: EOF: INMEMO.PRG
